﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using Microsoft.Practices.Composite.UnityExtensions;

namespace infraGridBug
{
    public class Bootstrapper : UnityBootstrapper
    {
        protected override DependencyObject CreateShell()
        {
            RegisterViewsAndServices();

            var view = Container.Resolve<Window1>();
#if SILVERLIGHT
            App.Current.RootVisual = shell;
#else
            view.Show();
#endif

            return view;
        }

        protected override void InitializeModules()
        {

            //IModule moduleA = Container.Resolve<ModuleA.ModuleA>();
            //IModule moduleB = Container.Resolve<ModuleB.ModuleB>();

            //moduleA.Initialize();
            //moduleB.Initialize();
        }

        protected void RegisterViewsAndServices()
        {

            this.Container.RegisterType<IWindow1ViewModel, Window1ViewModel>();
            //this.Container.RegisterType()
        }
    }
}
