﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;

namespace infraGridBug
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Infragistics.Windows.Ribbon.XamRibbonWindow
    {

        public Window1(IWindow1ViewModel model)
        {
            InitializeComponent();
            DataContext = model;
            ((ObjectDataProvider)this.Resources["tstODP"]).ObjectInstance = DataContext;
            //ObjectDataProvider tstODP = this.Resources["tstODP"] as ObjectDataProvider;
            //tstODP.ObjectInstance = DataContext;
            //myStackPanel.Children.Add(new TestControl());
            //myStackPanel.Children.Add(new TestControl());
        }

        //public Window1()
        //{
        //    //InitializeComponent();
        //    //DataContext = Resources["viewModel"];
        //    //InitializeComponent();
        //    //myStackPanel.Children.Add(new TestControl());
        //    //myStackPanel.Children.Add(new TestControl());
        //}

        private void tst_RecordsInViewChanged(object sender, Infragistics.Windows.DataPresenter.Events.RecordsInViewChangedEventArgs e)
        {

        }

        private void tst_DataValueChanged(object sender, Infragistics.Windows.DataPresenter.Events.DataValueChangedEventArgs e)
        {
           
            if (e.CellValuePresenter.Record.RecordType != RecordType.DataRecord) return;
            
            //I WILL UPDATE THE RECORD TAGS ALSO SO RESETTING IS MUCH more efficient;
            
            var blah =e.ValueHistory.AsQueryable();
            if(e.Record.Cells[e.Field].Tag==null)
            {
                e.Record.Cells[e.Field].Tag = e.ValueHistory[1].Value;
                e.Record.Tag = (bool)true;
            }

        }

        private void ClearHistory(XamDataPresenter xdp)
        {
            #region commented for later implimentation

            //THIS SECTION MAY BE REQUIRED LATER BUT YOU CANNOT USE FIELDS HERE AND RECORDS BELOW
            //AS EACH RECORD MAY NOT HAVE THE SAME FIELDS (IE EXPANDED LIKE IN PM)

            //var blah4 = (IEnumerable<FieldCollection>)xdp.FieldLayouts.Select(x => x.Fields).AsQueryable();
            //foreach (FieldCollection fieldCollection in blah4)
            //{
            //    //.Where(
            //    //y => y.Settings.DataValueChangedNotificationsActive == true);
            //}
            #endregion


            //var blah3 =
                //((IEnumerable<Record>) (xdp.Records.Where(x => x.RecordType == RecordType.DataRecord)).Where(x=>x.Tag !=null).AsQueryable());

            //var blah4 = blah3.Where(x => x.Tag != null);
            //only updating records with changes as noted by the records 'tag')
            foreach (var blah2 in ((IEnumerable<Record>)(xdp.Records.Where(x => x.RecordType == RecordType.DataRecord)).Where(x => x.Tag != null).AsQueryable()))
            {
                foreach (var cell in (((DataRecord)blah2).Cells).Where(x=>x.Tag!=null))
                {
                    cell.Tag = null;
                }
            }
        }

        private void tst_InitializeCellValuePresenter(object sender, Infragistics.Windows.DataPresenter.Events.InitializeCellValuePresenterEventArgs e)
        {
            try
            {


                if (e.CellValuePresenter.Record.RecordType != RecordType.DataRecord) return;

                var cellTagValue = e.CellValuePresenter.Record.Cells[e.CellValuePresenter.Field].Tag;
                var currentCellValuePresenterValue = e.CellValuePresenter.Value == null ? string.Empty : e.CellValuePresenter.Value.ToString();

                if (cellTagValue == null) //This check slows down the process but must be added as infra grid currently has a bug.
                {
                    //e.CellValuePresenter.Background = Brushes.White;
                    return; //No update if tag is null
                }


                

                if (currentCellValuePresenterValue != cellTagValue.ToString())
                    e.CellValuePresenter.Background = Brushes.Yellow;
                else e.CellValuePresenter.Background = Brushes.White;
            }
            catch (Exception ex)
            {
                //NEED ERROR HANDLER IN HERE. (And everywhere in this project).
                Console.WriteLine(ex);
            }


        }


    }
}
